Enemy = {}

-- CONSTRUCTOR
function Enemy:new(type, x, y)
    local object = {
		x = x,
		y = y,
		alive = true,
		deleteIt = false,
		currentAnimation = 1,
		currentFrame = 1,
		frameTicker = 0,
		mTick1 = 0,
		mTick2 = 0,
		mTick3 = 0,
		mTick4 = 0,
		mTick5 = 0,
		mTick6 = 0,
		mTick7 = 0,
		fireTick = 0,
		flushme = false,
		val = 0
    }

	-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
	totalobjects = totalobjects + 1

	-- ADD DEFAULT Y COORD IF THERE ISN'T ONE
	if not object.y then object.y = -50 end



	-------------------------------------------------------- ENEMY TYPES

	if type == "asteroid1" then
		object.width = 11; object.height = 11; object.speed = (math.random(40, 200)+level.asteroidsSpeed); object.hitX = 5; object.hitY = 5
		object.hitW = 11; object.hitH = 11; object.type = "asteroid"; object.animSpeed = 0.10
		object.animations = {

			{IMG_a1f1, IMG_a1f2, IMG_a1f3, IMG_a1f4},
			{IMG_blank}

		}
	end

	if type == "asteroid2" then
		object.width = 21; object.height = 21; object.speed = (math.random(40, 200)+level.asteroidsSpeed); object.hitX = 5; object.hitY = 5
		object.hitW = 21; object.hitH = 21; object.type = "asteroid"; object.animSpeed = 0.10
		object.animations = {

			{IMG_a2f1, IMG_a2f2, IMG_a2f3, IMG_a2f4},
			{IMG_blank}

		}
	end

	if type == "asteroid3" then
		object.width = 30; object.height = 30; object.speed = (math.random(40, 200)+level.asteroidsSpeed); object.hitX = 5; object.hitY = 5
		object.hitW = 30; object.hitH = 30; object.type = "asteroid"; object.animSpeed = 0.10
		object.animations = {

			{IMG_a3f1, IMG_a3f2, IMG_a3f3, IMG_a3f4},
			{IMG_blank}

		}
	end

	if type == "asteroid4" then
		object.width = 41; object.height = 41; object.speed = math.random(40, 200); object.hitX = 5; object.hitY = 5
		object.hitW = 41; object.hitH = 41; object.type = "asteroid"; object.animSpeed = 0.10
		object.animations = {

			{IMG_a4f1, IMG_a4f2, IMG_a4f3, IMG_a4f4},
			{IMG_blank}

		}
	end


	if type == 1 then
		object.val = 2
		object.width = 23; object.height = 23; object.speed = 20; object.hitX = 7; object.hitY = 7
		object.hitW = 9; object.hitH = 9; object.type = 1; object.animSpeed = 0.3
		object.animations = {

			{IMG_e1f1, IMG_e1f2, IMG_e1f3, IMG_e1f2},
			{IMG_blank}

		}
	end


	if type == 2 then
		object.val = 4
		SND_enemy2:seek(0); SND_enemy2:play()
		object.width = 29; object.height = 29; object.speed = 60; object.hitX = 8; object.hitY = 7
		object.hitW = 13; object.hitH = 14; object.type = 2; object.animSpeed = 0.3
		object.animations = {

			{IMG_e2f1, IMG_e2f2, IMG_e2f3, IMG_e2f2},
			{IMG_blank}

		}
	end


	if type == 3 then
		object.val = 8
		object.width = 30; object.height = 30; object.speed = 10; object.hitX = 7; object.hitY = 7
		object.hitW = 16; object.hitH = 13; object.type = 3; object.animSpeed = 0.3
		object.animations = {

			{IMG_e3f1, IMG_e3f2, IMG_e3f3, IMG_e3f4, IMG_e3f5, IMG_e3f4, IMG_e3f1},
			{IMG_blank}

		}
	end


	if type == 4 then
		object.val = 10
		object.width = 29; object.height = 21; object.speed = 10; object.hitX = 6; object.hitY = 6
		object.hitW = 18; object.hitH = 9; object.type = 4; object.animSpeed = 0.2
		object.animations = {

			{IMG_e4f1, IMG_e4f2, IMG_e4f3},
			{IMG_blank}

		}
	end

   if type == 6 then
		object.val = 1
		object.width = 17; object.height = 14; object.speed = 30; object.hitX = 5; object.hitY = 5
		object.hitW = 17; object.hitH = 14; object.type = 6; object.animSpeed = 0.3
		object.animations = {

			{IMG_e6f1, IMG_e6f2, IMG_e6f3, IMG_e6f4},
			{IMG_blank}

		}
	end

   if type == 7 then
		object.val = 40
		object.width = 15; object.height = 15; object.speed = 10; object.hitX = 5; object.hitY = 5
		object.hitW = 15; object.hitH = 15; object.type = 7; object.animSpeed = 0.2
		object.animations = {

			{IMG_e7f1, IMG_e7f2, IMG_e7f3, IMG_e7f4, IMG_e7f5, IMG_e7f6},
			{IMG_blank}

		}
	end

	if type == 8 then
		object.val = 25
		object.width = 38; object.height = 27; object.speed = 7; object.hitX = 16; object.hitY = 9
		object.hitW = 6; object.hitH = 3; object.type = 8; object.animSpeed = 0.09
		object.animations = {

			{IMG_e8f1, IMG_e8f2},
			{IMG_blank}

		}
	end

	if type == 9 then
		object.val = 30
		object.width = 40; object.height = 30; object.speed = 10; object.hitX = 6; object.hitY = 6
		object.hitW = 28; object.hitH = 17; object.type = 9; object.animSpeed = 0.24
		object.animations = {

			{IMG_e9f5, IMG_e9f6, IMG_e9f5, IMG_e9f6, IMG_e9f5, IMG_e9f5, IMG_e9f1, IMG_e9f2, IMG_e9f3, IMG_e9f4, IMG_e9f3, IMG_e9f2, IMG_e9f1},
			{IMG_blank}

		}
	end

	if type == 10 then
		object.val = 4
		object.width = 17; object.height = 14; object.speed = 40; object.hitX = 5; object.hitY = 5
		object.hitW = 17; object.hitH = 14; object.type = 10; object.animSpeed = 0.3
		object.animations = {

			{IMG_e10f1, IMG_e10f2, IMG_e10f3, IMG_e10f4},
			{IMG_blank}

		}
	end




    setmetatable(object, { __index = Enemy })
    return object
end


function Enemy:update(dt)

	-- ANIMATE
	self.frameTicker = self.frameTicker + dt
	if self.frameTicker > self.animSpeed then
		if (self.currentFrame+1) <= table.getn(self.animations[self.currentAnimation]) then
			self.currentFrame = self.currentFrame + 1
			self.frameTicker = 0
		else
			self.currentFrame = 1
			self.frameTicker = 0
		end
	end



	-------------------------------------------------------------------------------- MOVEMENT BEHAVIOR AND FIRING PATTERN
	if self.alive then

		if self.type == "asteroid" then
			self.y = self.y + self.speed*dt
		end



		if self.type == 1 then
			self.y = self.y + self.speed*dt
			self.mTick1 = self.mTick1 + dt
			if self.mTick1 > 2.3 then
				-- FIRE
				SND_enemy1:seek(0); SND_enemy1:play()
				local bullet = Bullet:new(1, self.x+4, self.y+10, 0, 106)
				ebullets[#ebullets+1] = bullet
				self.mTick1 = 0
			end
		end



		if self.type == 2 then
			if p.state == "alive" then
				if p.x > self.x+3 then
					if self.y < 130 then
						self.x = self.x + self.speed*dt
					else
						self.x = self.x + (self.speed*3)*dt
					end
				elseif p.x < self.x-3 then
					if self.y < 130 then
						self.x = self.x - self.speed*dt
					else
						self.x = self.x - (self.speed*3)*dt
					end
				end
			end
			self.y = self.y + (self.speed*1.6)*dt
		end



		if self.type == 3 then
			self.mTick2 = self.mTick2 + dt; self.mTick3 = self.mTick3 + dt
			if self.mTick2 > 4 then
				self.mTick4 = math.random(0,6)
				self.mTick2 = 0
			end
			if self.mTick4 == 0 or self.mTick4 == 3 or self.mTick4 == 4 or self.mTick4 == 5 or self.mTick4 == 6 then
				self.y = self.y + self.speed*dt
			elseif self.mTick4 == 1 then
				self.x = self.x - 22*dt
			elseif self.mTick4 == 2 then
				self.x = self.x + 22*dt
			end

			if self.x < 0 then self.flushme = true end
			if self.x > 320 then self.flushme = true end
			if self.y > 160 then self.flushme = true end

			self.mTick1 = self.mTick1 + dt
			if self.mTick1 > 3 then
				-- FIRE
				SND_enemy3:seek(0); SND_enemy3:play()
				local bullet = Bullet:new(2, self.x+7, self.y+16, 0, 40)
				ebullets[#ebullets+1] = bullet
				local bullet = Bullet:new(2, self.x+7, self.y+16, -40, 40)
				ebullets[#ebullets+1] = bullet
				local bullet = Bullet:new(2, self.x+7, self.y+16, 40, 40)
				ebullets[#ebullets+1] = bullet
				self.mTick1 = 0
				-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
				totalobjects = totalobjects + 3
			end
		end



		if self.type == 4 then
			if self.y < 30 then
				self.y = self.y + self.speed*dt
			else
				self.mTick2 = self.mTick2 + dt
				self.mTick1 = self.mTick1 + dt
				if self.mTick2 > 3 then
					self.mTick3 = math.random(1,2)
					self.mTick2 = 0
				end
				if self.mTick3 == 1 then
					if self.x < 291 then self.x = self.x + self.speed*dt end
				else
					if self.x > 10 then self.x = self.x - self.speed*dt end
				end
				if self.mTick1 > 1.2 then
					-- FIRE
					SND_enemy4:seek(0); SND_enemy4:play()
					local bullet = Bullet:new(3, self.x+4, self.y+5, 0, 200)
					ebullets[#ebullets+1] = bullet
					self.mTick1 = 0
					-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
					totalobjects = totalobjects + 1
				end
			end
		end

      if self.type == 6 then
			self.y = self.y + self.speed*dt
			self.mTick1 = self.mTick1 + dt
			if self.mTick1 > 2.3 then
				-- FIRE
            --[[
				SND_enemy1:seek(0); SND_enemy1:play()
				local bullet = Bullet:new(1, self.x+4, self.y+10, 0, 106)
				ebullets[#ebullets+1] = bullet
            ]]--
				self.mTick1 = 0
			end
		end

      if self.type == 7 then
			self.y = self.y + self.speed*dt
			self.mTick1 = self.mTick1 + dt
			if self.mTick1 > 1.8 then
				-- FIRE
				SND_enemy1:seek(0); SND_enemy1:play()
				local bullet = Bullet:new(6, self.x+6, self.y+13, -40, 80)
            ebullets[#ebullets+1] = bullet
            local bullet = Bullet:new(6, self.x+6, self.y+13, 0, 90)
            ebullets[#ebullets+1] = bullet
            local bullet = Bullet:new(6, self.x+6, self.y+13, 40, 80)
				ebullets[#ebullets+1] = bullet
				self.mTick1 = 0
			end
		end

		if self.type == 8 then
			self.y = self.y + self.speed*dt
			self.mTick1 = self.mTick1 + dt
			if self.mTick1 > 5 then
				-- FIRE
				SND_enemy5:seek(0); SND_enemy5:play()
				local bullet = Bullet:new(4, self.x+0, self.y+15, -6, 70); ebullets[#ebullets+1] = bullet
				local bullet = Bullet:new(4, self.x+6, self.y+15, 0, 70); ebullets[#ebullets+1] = bullet
				local bullet = Bullet:new(4, self.x+19, self.y+15, 0, 70); ebullets[#ebullets+1] = bullet
				local bullet = Bullet:new(4, self.x+25, self.y+15, 6, 70); ebullets[#ebullets+1] = bullet
				self.mTick1 = 0
			end
		end


		if self.type == 9 then
			self.y = self.y + self.speed*dt
			self.mTick1 = self.mTick1 + dt
			if self.x > p.x+3 then
				self.x = self.x - 16*dt
			elseif self.x < p.x-3 then
				self.x = self.x + 16*dt
			end
			if self.mTick1 > 2.3 then
				-- FIRE
				SND_enemy6:seek(0); SND_enemy6:play()
				local bullet = Bullet:new(5, self.x+12, self.y+15, 0, 40)
				ebullets[#ebullets+1] = bullet
				self.mTick1 = 0
			end
		end

		if self.type == 10 then
			self.y = self.y + self.speed*dt
			self.mTick1 = self.mTick1 + dt
			if self.mTick1 > 2 then
				if self.mTick2 == 0 then
					self.mTick2 = 1
				else
					self.mTick2 = 0
				end
				self.mTick1 = 0
			end
			if self.mTick2 == 0 then
				self.x = self.x + self.speed*dt
			else
				self.x = self.x - self.speed*dt
			end
		end

	end

	-- FLUSH ENEMY
	if self.flushme then
		self.y = self.y + (40*dt)
	end

	-- DELETE IF BELOW SCREEN
	if self.y > 200 then
		self.deleteIt = true
	end
end


function Enemy:kill()
	local poof = explosion:new(self.x+(self.width/2), self.y+(self.width/2), 255, 255, 255)
	table.insert(explosions, poof)
	self.deleteIt = true
	self.currentFrame = 1
	self.alive = false
	score = score + self.val
end


function Enemy:draw()
	g.draw(self.animations[self.currentAnimation][self.currentFrame], self.x*scale, self.y*scale, 0, crtscale, crtscale)
end
