timer = {}
 
 --[[
 
 USAGE
 
function timer:new({ {Delay, Loops, Actions}  }) 
 
 
]]-- 
 
 
-- CONSTRUCTOR
function timer:new(timers)
    local object = {
		timers = timers,
		tick = 0,
		currentTimer = 1,
		deleteMe = false
    }
    setmetatable(object, { __index = timer })
    return object
end


function timer:update(dt)
	
	if self.timers[self.currentTimer] then
		self.tick = self.tick + dt
		if self.tick >= self.timers[self.currentTimer][1] then
			self.tick = 0
			if self.timers[self.currentTimer][2] > 0 then
				self.timers[self.currentTimer][2] = self.timers[self.currentTimer][2] - 1
				local chunk = loadstring(self.timers[self.currentTimer][3])
				chunk()
			else
				self.currentTimer = self.currentTimer + 1
			end
		end
	else
		self.deleteMe = true
	end
	
end


function timer:draw()
	
end