g = love.graphics
local imgFolder = love.filesystem.getDirectoryItems("images")
for i=1, #imgFolder do
	local file = imgFolder[i]
	local instanceName = file:gsub(".png", "")
	local chunk = loadstring("IMG_"..instanceName.." = g.newImage('images/"..file.."')")
	chunk()
end


-- SOUNDS
musicVolume = 0.80
SND_beep = love.audio.newSource("sounds/beep.ogg", "static")
SND_select = love.audio.newSource("sounds/select.ogg", "static")
SND_blip = love.audio.newSource("sounds/blip.ogg", "static")
SND_bullet = love.audio.newSource("sounds/bullet.ogg", "static")
SND_explosion1 = love.audio.newSource("sounds/explosion1.ogg", "static")
SND_pdeath = love.audio.newSource("sounds/pdeath.ogg", "static")
SND_levelup = love.audio.newSource("sounds/levelup.ogg", "static")
SND_enemy1 = love.audio.newSource("sounds/enemy1.ogg", "static")
SND_enemy2 = love.audio.newSource("sounds/enemy2.ogg", "static")
SND_enemy3 = love.audio.newSource("sounds/enemy3.ogg", "static")
SND_enemy4 = love.audio.newSource("sounds/enemy4.ogg", "static")
SND_enemy5 = love.audio.newSource("sounds/enemy5.ogg", "static")
SND_enemy6 = love.audio.newSource("sounds/enemy6.ogg", "static")
SND_gameover = love.audio.newSource("sounds/gameover.ogg", "stream")
SND_theme = love.audio.newSource("sounds/starseeker.ogg", "stream")
SND_asteroid = love.audio.newSource("sounds/asteroid.ogg", "stream"); SND_asteroid:setLooping(true); SND_asteroid:setVolume(.92)
SND_song1 = love.audio.newSource("sounds/song1.ogg", "stream"); SND_song1:setLooping(true); SND_song1:setVolume(.60)
SND_song2 = love.audio.newSource("sounds/song2.ogg", "stream"); SND_song2:setLooping(true); SND_song2:setVolume(.70)
SND_song3 = love.audio.newSource("sounds/song3.ogg", "stream"); SND_song3:setLooping(true); SND_song3:setVolume(musicVolume)
SND_song4 = love.audio.newSource("sounds/song4.ogg", "stream"); SND_song4:setLooping(true); SND_song4:setVolume(musicVolume)
SND_song5 = love.audio.newSource("sounds/song5.ogg", "stream"); SND_song5:setLooping(true); SND_song5:setVolume(.60)
SND_silence = love.audio.newSource("sounds/silence.ogg", "stream"); SND_silence:setLooping(true); SND_silence:setVolume(.60)
